(* Release 3.10 *)(*fix*)(* For CW5 *)
(*-------------------------------------------------------------------------*
*                                                                          *
*  STR.MOD - String functions                                              *
*                                                                          *
*  COPYRIGHT (C) 1987..1992 Clarion Software Corporation.                  *
*  All Rights Reserved                                                     *
*                                                                          *
*  Modified for Topspeed Clarion V5.0    CWS    08-16-00                   *
*  Change 'LONGCARD(Var)' to the form 'VAL(LONCARD, Var)'.  CWS  08-17-01  *
*  Change 'REAL(Var)' to the form 'VAL(REAL, Var)'.         CWS  08-17-01  *
*                                                                          *
*--------------------------------------------------------------------------*)

(*# call(o_a_copy => off) *)
(*# check(stack=>off,
          index=>off,
          range=>off,
          overflow=>off,
          nil_ptr=>off) *)

IMPLEMENTATION MODULE Str;

IMPORT Lib, CWRUN;

TYPE
  Bptr = POINTER TO BYTE;

CONST
  StrictRealConv = FALSE ;

(* ----
  PROCEDURE Same(Stg,Pattern:ARRAY OF CHAR):BOOLEAN; IN AsmLib;
  PROCEDURE Count(Stg:ARRAY OF CHAR;Ch:CHAR):CARDINAL; IN AsmLib;
 ---- *)




(* Was in MathLib *)
PROCEDURE IntPow(X:LONGREAL; K:INTEGER): LONGREAL;
VAR Rslt: LONGREAL;  Ix: CARDINAL;
BEGIN
  IF K = 0 THEN                    (* 08-07-00 *)
    Rslt := 1.0;                   (* 08-07-00 *)
  ELSE
    Rslt := X;
    IF K > 1 THEN
      FOR Ix := 2 TO K DO          (* 08-07-00 *)
        Rslt := Rslt * X;
      END;
    END;
  END;
  RETURN Rslt;
END IntPow;




(* Was in ASMLIB *)
(* ----
PROCEDURE Lows(VAR S: ARRAY OF CHAR);       (* 03-29-99 *)
VAR I : CARDINAL;
BEGIN
  FOR I := 0 TO HIGH(S) DO S[I] := XXXXXX; END;
END Lows;
 ---- *)


(* Was in ASMLIB *)
PROCEDURE RCharPos(S: ARRAY OF CHAR; C: CHAR) : CARDINAL;
VAR
  Ix, HS : CARDINAL;
BEGIN
  HS := Length(S);     (* 03-29-99 *)
  IF HS = 0 THEN RETURN MAX(CARDINAL) END;
  Ix := HS-1;           (* 03-29-99 *)
  LOOP
    IF S[Ix] = C THEN EXIT END;   (* 03-29-99 *)
    IF Ix = 0 THEN RETURN MAX(CARDINAL) END;    (* 03-29-99 *)
    DEC(Ix);
  END;
  RETURN Ix;
END RCharPos;


(* Was in ASMLIB *)
PROCEDURE NextPos(S,P: ARRAY OF CHAR; Place: CARDINAL) : CARDINAL;   (* 03-29-99 *)
VAR
  I,J,K,HP,HS : CARDINAL;
BEGIN
  HP := HIGH(P);
  HS := HIGH(S);
  I  := Place;                  (* 03-29-99 *)
  LOOP
    IF (I > HS) OR (S[I] = CHR(0)) THEN RETURN MAX(CARDINAL) END;
    J := 0;
    K := I;
    LOOP
      IF (J > HP) OR (P[J] = CHR(0)) THEN RETURN I END;
      IF K > HS THEN RETURN MAX( CARDINAL ); END;
      IF S[K] # P[J] THEN EXIT END;
      INC(J);
      INC(K);
    END;
    INC(I);
  END;
END NextPos;


(* Was in ASMLIB *)
PROCEDURE CharPos(S: ARRAY OF CHAR; C: CHAR) : CARDINAL;  (* 03-29-99 *)
VAR
  Ix, HS : CARDINAL;
BEGIN
  HS := HIGH(S);
  Ix := 0;
  LOOP
    IF (Ix > HS) OR (S[Ix] = CHR(0)) THEN RETURN MAX(CARDINAL) END;
    IF S[Ix] = C THEN EXIT END;
    INC(Ix);
  END;
  RETURN Ix;
END CharPos;


(* Was in ASMLIB *)
PROCEDURE Slice (VAR R: ARRAY OF CHAR; S: ARRAY OF CHAR; P,L: CARDINAL);   (* 03-17-99 *)
VAR  I, J: CARDINAL;
BEGIN
  I := HIGH(R)+1;
  J := Length(S);
  IF L > J THEN L := J; END;
  IF L > I THEN L := I; END;
  Lib.Move( ADR(S[P]), ADR(R), L );                  (* 04-29-99 *)
  IF L < I THEN R[ L(*-1+1*) ] := CHR(0); END;
END Slice;




PROCEDURE Prepend(VAR S1: ARRAY OF CHAR; S2: ARRAY OF CHAR);

VAR
    ShiftLen: CARDINAL;
    S1Len, S2Len, Ix, Iy: CARDINAL;                  (* 08-16-00 *)
BEGIN
    S1Len:=Length(S1)+1;
    S2Len:=Length(S2);
    IF S2Len > HIGH(S1) THEN
        Copy(S1, S2);
        RETURN;
    END;
    ShiftLen:=HIGH(S1)-S2Len + 1;
    IF ShiftLen > S1Len THEN ShiftLen:=S1Len END;
    Ix := S2Len+ShiftLen;                            (* 08-16-00 *)
    Iy := ShiftLen;                                  (* 08-16-00 *)
    LOOP  (* move from right *)                      (* 08-16-00 *)
      S1[Ix] := S1[Iy];                              (* 08-16-00 *)
      IF Iy = 0 THEN EXIT; END;                      (* 08-16-00 *)
      DEC(Ix); DEC(Iy);                              (* 08-16-00 *)
    END; (* loop *)
    Lib.Move(ADR(S2), ADR(S1), S2Len);
END Prepend;

PROCEDURE Subst(VAR S1: ARRAY OF CHAR; Target: ARRAY OF CHAR; New: ARRAY OF CHAR);

VAR
    TargetPos, TargetLen: CARDINAL;
BEGIN
    TargetPos:=Pos(S1, Target);
    IF TargetPos = MAX(CARDINAL) THEN RETURN END;
    TargetLen:=Length(Target);
    Lib.Move(ADR(S1[TargetPos+TargetLen]), ADR(S1[TargetPos]), Length(S1)-TargetLen-TargetPos+1);
    Insert(S1, New, TargetPos);
END Subst;

PROCEDURE Delete(VAR S: ARRAY OF CHAR; P,L: CARDINAL);
VAR
  Le,I : CARDINAL;
BEGIN
  IF L # 0 THEN
    Le := Length(S);
    IF P < Le THEN
      IF L < Le - P THEN
        I := P+L;
        REPEAT
          S[P] := S[I];
          INC(P);
          INC(I);
        UNTIL I=Le;
      END;
      S[P] := CHR(0);
    END;
  END;
END Delete;

PROCEDURE Insert(VAR S1: ARRAY OF CHAR; S2: ARRAY OF CHAR; P: CARDINAL);
VAR
  I,J,C,L : CARDINAL;
BEGIN
  L := Length(S1);
  I := Length(S2);
  C := L;
  IF C < P THEN P := C END;
  DEC(C,P);
  FOR J := C TO 0 BY -1 DO
    IF (J+P+I <= HIGH(S1)) THEN S1[J+P+I] := S1[J+P]; END;
  END;
  J := 0;
  WHILE (J<I) AND (P+J <= HIGH(S1)) DO
    S1[P+J] := S2[J];
    INC(J);
  END;
END Insert;

PROCEDURE Item(VAR R: ARRAY OF CHAR; S: ARRAY OF CHAR; T: CHARSET; N: CARDINAL);
VAR
  I,J  : CARDINAL;
  HR,L : CARDINAL;
BEGIN
  I := 0;
  L := Length(S);
  LOOP
    WHILE (I < L) AND (S[I] IN T) DO INC(I); END; (* Skip separators *)
    IF (N = 0) OR (I = L) THEN EXIT END;
    DEC(N);
    WHILE (I < L) AND NOT (S[I] IN T) DO INC(I); END; (* Skip item *)
  END;
  J  := 0;
  HR := HIGH(R);
  WHILE (I < L) AND NOT (S[I] IN T) AND (J <= HR) DO
    R[J] := S[I];
    INC(I);
    INC(J);
  END;
  IF (J <= HR) THEN R[J] := CHR(0); END;
END Item;

PROCEDURE ItemS(VAR R: ARRAY OF CHAR; S: ARRAY OF CHAR;
                    T: ARRAY OF CHAR; N: CARDINAL);
VAR
  CS : CHARSET;
  I  : CARDINAL;
BEGIN
  I  := Length(T);
  CS := CHARSET{};
  WHILE I>0 DO
    DEC(I);
    INCL(CS,T[I]);
  END;
  Item(R,S,CS,N);
END ItemS;

PROCEDURE Match(Source,Pattern: ARRAY OF CHAR) : BOOLEAN;
(*
  returns TRUE if the string in Source matches the string in Pattern
  The pattern may contain any number of the wild characters '*' and '?'
  '?' matches any single character
  '*' matches any sequence of charcters (including a zero length sequence)
  EG '*m?t*i*' will match 'Automatic'
*)

   PROCEDURE Rmatch(VAR s: ARRAY OF CHAR; i: CARDINAL;
                    VAR p: ARRAY OF CHAR; j: CARDINAL) : BOOLEAN;

   (* s = to be tested ,    i = position in s *)
   (* p = pattern to match ,j = position in p *)

   VAR
     matched: BOOLEAN;
     k      : CARDINAL;
   BEGIN
     IF p[0]=CHR(0) THEN RETURN TRUE END;
     LOOP
       IF ((i > HIGH(s)) OR (s[i] = CHR(0))) AND
          ((j > HIGH(p)) OR (p[j] = CHR(0))) THEN
         RETURN TRUE
       ELSIF ((j > HIGH(p)) OR (p[j] = CHR(0))) THEN
         RETURN FALSE
       ELSIF (p[j] = '*') THEN
         k :=i;
         IF ((j = HIGH(p)) OR (p[j+1] = CHR(0))) THEN
           RETURN TRUE
         ELSE
           LOOP
             matched := Rmatch(s,k,p,j+1);
             IF matched OR (k > HIGH(s)) OR (s[k] = CHR(0)) THEN
               RETURN matched;
             END;
             INC(k);
           END;
         END
       ELSIF ((p[j]='?')AND(s[i]<>0C)) OR (CAP(p[j]) = CAP(s[i])) THEN
         INC(i);
         INC(j);
       ELSE
         RETURN FALSE;
       END;
     END;
   END Rmatch;

BEGIN
  RETURN Rmatch(Source,0,Pattern,0);
END Match;

TYPE
  ConvIntType = ARRAY ['0'..'F'] OF SHORTCARD;
  BA          = ARRAY[0..1] OF SHORTCARD;

CONST
  ConvStr = '0123456789ABCDEF';
  ConvInt = ConvIntType( 0,1,2,3,4,5,6,7,8,9,255,255,255,255,255,255,255,10,11,12,13,14,15 );
  Div     = BA(0,4);

VAR FloatUse : BOOLEAN;


(*%T _WINDOWS *)
  PROCEDURE FixRealToStr(V:LONGREAL;Precision:CARDINAL;VAR S:ARRAY OF CHAR;VAR OK:BOOLEAN);
    VAR
      j,l,m             : INTEGER;
      t                 : LONGREAL;
    BEGIN
      OK := TRUE;
      IF V = 0.0 THEN
        FOR j := 0 TO Precision + 1 DO
          S[j] := '0';
        END; (*FOR*)
        S[1] := '.';
        S[Precision+2] := 0C;
      ELSE
        S[0] := 0C;
        IF V < 0.0 THEN
          Copy(S,'-');
          V := -V;
        END; (*IF*)
        t := IntPow( 10.0, Precision );  (* CWS *)
        V := (V * t + 0.5) / t;
        m := TRUNC( CWRUN.LOG10(V) );  (* CWS *)
        IF m <= 0 THEN
          l := 0;
          t := V;
        ELSE
          l := m;
          t := V / IntPow( 10.0, m );  (* CWS *)
        END; (*IF*)
        FOR j := l TO (-INTEGER(Precision)) BY -1 DO
          Append(S,CHR(TRUNC(t) + 48));
          IF j = 0 THEN
            Append(S,'.');
          END; (*IF*)
          t := (t - VAL(LONGREAL, TRUNC(t))) * 10.0;    (* 08-17-01 *)
        END; (*FOR*)
      END; (*IF*)
    END FixRealToStr;
(*%E *)

PROCEDURE CheckBase(VAR b: CARDINAL);
BEGIN
  IF b < 2  THEN b := 2; END;
  IF b > 16 THEN b := 16; END;
END CheckBase;

PROCEDURE Reverse(VAR s: ARRAY OF CHAR; l,h: CARDINAL);
VAR T : CHAR;
BEGIN
  WHILE l < h DO
    T := s[l];
    s[l] := s[h];
    s[h] := T;
    INC(l);
    DEC(h);
  END;
END Reverse;


PROCEDURE IntToStr(V: LONGINT;VAR S: ARRAY OF CHAR; Base: CARDINAL; VAR OK: BOOLEAN);
VAR
  i,l : CARDINAL;
  b   : LONGCARD;
BEGIN
  OK := TRUE;
  l  := HIGH(S);
  CheckBase( Base );
  b := VAL( LONGCARD,Base );
  IF V < 0 THEN
    S[0] := '-';
    i := 1;
    V := -V;
  ELSIF FloatUse THEN
    S[0] := '+';
    i := 1;
  ELSE
    i := 0;
  END;

  LOOP
    IF i > l THEN OK := FALSE; EXIT; END;
    S[i] := ConvStr[CARDINAL( LONGCARD(V) MOD b )];
    INC(i);
    V := LONGCARD(V) DIV b;
    IF V = 0 THEN EXIT END;
  END;
  IF i <= l THEN S[i] := CHR(0); END;
  IF S[0] < '0' THEN
    Reverse( S,1,i-1 );
  ELSE
    Reverse( S,0,i-1 );
  END;
END IntToStr;


PROCEDURE CardToStr(V: LONGCARD; VAR S: ARRAY OF CHAR;
                    Base: CARDINAL; VAR OK: BOOLEAN);
VAR
  i,l : CARDINAL;
  b   : LONGCARD;
BEGIN
  OK := TRUE;
  l  := HIGH(S);
  CheckBase( Base );
  b := VAL( LONGCARD,Base );
  i := 0;
  LOOP
    IF i > l THEN OK := FALSE; EXIT END;
    S[i] := ConvStr[CARDINAL( V MOD b )];
    INC(i);
    V := V DIV b;
    IF V = 0 THEN EXIT END;
  END;
  IF i <= l THEN S[i] := CHR(0); END;
  Reverse( S,0,i-1 );
END CardToStr;


(*$V-*)
PROCEDURE StrToCI(S: ARRAY OF CHAR; Base: CARDINAL; VAR OK: BOOLEAN) : LONGCARD;
VAR
  i,l   : CARDINAL;
  b,t,y : LONGCARD;
  c     : CHAR;
  x     : SHORTCARD;
BEGIN
  CheckBase( Base );
  b := VAL( LONGCARD,Base);
  i := 0;
  l := HIGH( S );
  IF (S[0] = '-') OR (S[0] = '+') THEN
    i := 1;
  END;
  t := 0;
  IF S[i] = CHR(0) THEN OK := FALSE; END;
  WHILE (i <= l) AND (S[i] # CHR(0)) DO
    c := S[i];
    IF ( (Base=10) AND ((c<'0') OR (c>'9')) ) OR   (*fix*)
       ( (Base=16) AND ((c<'0') OR (c>'F')) ) OR   (*fix*)
       ( (Base<10) AND ((c<'0') OR (c>CHR(48+Base))) ) THEN   (*fix*)
      OK := FALSE;
      RETURN t;
    END;
    x := ConvInt[c];
    IF (x > SHORTCARD(b)-1 ) OR (t > (MAX(LONGCARD)-VAL(LONGCARD, x)) DIV b) THEN OK := FALSE; END;  (* 08-17-01 *)
    t := t*b+VAL( LONGCARD,x );
    INC( i );
  END;
  RETURN t;
END StrToCI;


PROCEDURE StrToInt(S: ARRAY OF CHAR; Base: CARDINAL; VAR OK: BOOLEAN) : LONGINT;
VAR t : LONGCARD;
BEGIN
  OK := TRUE;
  t  := StrToCI( S,Base,OK);
  IF t > 7FFFFFFFH THEN OK := FALSE; END;
  IF S[0] = '-' THEN
    RETURN -LONGINT(t)
  ELSE
    RETURN LONGINT(t);
  END;
END StrToInt;


PROCEDURE StrToCard(S: ARRAY OF CHAR; Base: CARDINAL; VAR OK: BOOLEAN) : LONGCARD;
VAR t : LONGCARD;
BEGIN
  OK := TRUE;
  t  := StrToCI( S,Base,OK);
  IF S[0] = '-' THEN OK := FALSE; END;
  RETURN t;
END StrToCard;


  PROCEDURE StrToReal(S: ARRAY OF CHAR; VAR OK: BOOLEAN) : LONGREAL;
    CONST
      Zero              = 0.0;
    VAR
      c,expsign         : CHAR;
      exp,after         : INTEGER;
      i                 : CARDINAL;
      res,p10           : LONGREAL;
      Neg               : BOOLEAN;
    BEGIN
      OK  := TRUE;
      c   := S[0];
      Neg := FALSE;
      IF c = '+' THEN
        i := 1;
      ELSIF c = '-' THEN
        i := 1;
        Neg := TRUE;
      ELSE
        i := 0;
      END; (*IF*)
      res := Zero;
      c := S[i];
      WHILE (c # '.') & (i <= HIGH(S)) DO
        IF (c > '9') OR (c < '0') THEN
          IF StrictRealConv & (c = 0C) THEN
            OK := FALSE;
            RETURN Zero;
          ELSE
            IF ((c # 0C) & (c # 'E')) THEN   (*fix*)
              OK := FALSE;   (*fix*)
              RETURN Zero;   (*fix*)
            END;
            c := '.';
            DEC(i) ;
          END; (*IF*)
        ELSE
          res := res * 10.0 + VAL(LONGREAL,ORD(c) - ORD('0'));
          INC(i);
          c := S[i];
        END; (*IF*)
      END; (*WHILE*)
      after := 0;
      IF i >= HIGH(S) THEN
        IF StrictRealConv THEN
          OK := FALSE;
          RETURN Zero;
        ELSE
          RETURN res;
        END; (*IF*)
      END; (*IF*)
      INC(i);
      c := S[i];
      WHILE (i <= HIGH(S)) & (c # 0C) & (c # 'E') DO
        IF (c > '9') OR (c < '0') THEN
          OK := FALSE;
          RETURN Zero;
        END; (*IF*)
        res := res * 10.0 + VAL(LONGREAL,ORD(c) - ORD('0'));
        INC(i);
        INC(after);
        c := S[i];
      END; (*WHILE*)
      IF c = 'E' THEN
        INC(i);
        expsign := S[i];
        IF expsign = '+' THEN
          INC(i)
        ELSIF expsign = '-' THEN
          INC(i)
        END; (*IF*)
        c := S[i];
        exp := 0;
        WHILE (i <= HIGH(S)) & (c # 0C) DO
          IF (c > '9') OR (c < '0') THEN
            OK := FALSE;
            RETURN Zero;
          END; (*IF*)
          exp := exp * 8 + exp * 2 + INTEGER(ORD(c) - ORD('0'));
          INC(i);
          c := S[i];
        END; (*WHILE*)
        IF expsign = '-' THEN
          exp := -exp;
        END; (*IF*)
      ELSE
        exp := 0;
      END; (*IF*)
      exp := exp - after;
      p10 := 1.0;
      FOR i := 1 TO ABS(exp) DO
        p10 := p10 * 10.0;
      END; (*FOR*)
      IF Neg THEN
        res := - res;
      END; (*IF*)
      IF exp < 0 THEN
        RETURN res / p10;
      ELSE
        RETURN res * p10;
      END; (*IF*)
    END StrToReal;


(*%T _WINDOWS *)
  PROCEDURE RealToStr(V:LONGREAL;Precision:CARDINAL;Eng:BOOLEAN;VAR S:ARRAY OF CHAR;VAR OK:BOOLEAN);
    VAR
      j,w               : CARDINAL;
      m,i               : INTEGER;
      t                 : LONGREAL;
    BEGIN
      OK := TRUE;
      S[0] := 0C;
      m := 0;
      IF Precision > 17 THEN
        Precision := 17;
      END; (*IF*)
      IF V < 0.0 THEN
        Copy(S,'-');
        V := -V;
      END; (*IF*)
      IF V # 0.0 THEN
        m := TRUNC( CWRUN.LOG10(V) );  (* CWS *)
        IF m > 0 THEN
          V := V / IntPow( 10.0, m );  (* CWS *)
        END; (*IF*)
        IF V < 1.0 THEN
          V := V * 10.0;
          DEC(m);
        END;
        t := IntPow( 10.0, Precision );  (* CWS *)
        V := (V * t + 0.5) / t;
        IF V >= 10.0 THEN
          V := V / 10.0;
          INC(m);
        END; (*IF*)
        IF Eng THEN
          i := m;
          IF m > 0 THEN
            m := ((m + 2) DIV 3) * 3;
          ELSE
            m := ((m - 2) DIV 3) * 3;
          END; (*IF*)
          V := V / IntPow( 10.0, (m - i) );  (* CWS *)
        END; (*IF*)
      END; (*IF*)
      w := TRUNC(V);
      V := (V - VAL(LONGREAL, w)) * 10.0;             (* 08-17-01 *)
      IF Eng & (Precision > 0) THEN
        IF w DIV 100 > 0 THEN
          Str.Append(S,CHR((w DIV 100) + 48));
          w := w MOD 100;
          DEC(Precision);
        END; (*IF*)
        IF (w DIV 10 > 0) & (Precision > 0) THEN
          Str.Append(S,CHR((w DIV 10) + 48));
          w := w MOD 10;
          DEC(Precision);
        END; (*IF*)
      END; (*IF*)
      IF Precision > 0 THEN
        Str.Append(S,CHR(w + 48));
        DEC(Precision);
        Str.Append(S,'.');
        IF Precision > 0 THEN
          FOR j := 1 TO Precision DO
            Append(S,CHR(TRUNC(V) + 48));
            V := (V - VAL(LONGREAL, TRUNC(V))) * 10.0;   (* 08-17-01 *)
          END; (*FOR*)
        END; (*IF*)
      END; (*IF*)
      IF m < 0 THEN
        Str.Append(S,'E-');
        m := -m;
      ELSE
        Str.Append(S,'E+');
      END; (*IF*)
      IF m DIV 100 > 0 THEN
        Str.Append(S,CHR((m DIV 100) + 48));
        m := m MOD 100;
      END; (*IF*)
      IF m DIV 10 > 0 THEN
        Str.Append(S,CHR((m DIV 10) + 48));
      END; (*IF*)
      Str.Append(S,CHR((m MOD 10) + 48));
    END RealToStr;
(*%E *)

(*# save,call(o_a_copy=>off,o_a_size=>on)*)
  PROCEDURE FindSubStr(Source,Pattern:ARRAY OF CHAR;VAR Pos:ARRAY OF PosLen):BOOLEAN;
    VAR
      s,p,n,l           : CARDINAL;
    BEGIN
      Lib.Fill(ADR(Pos),SIZE(Pos),0FFH);
      IF Length(Source) = 0 THEN
        RETURN FALSE;
      END; (*IF*)
      l := Length(Pattern);
      IF l = 0 THEN
        Pos[0] := PosLen(0,0);
        RETURN TRUE;
      END; (*IF*)
      IF (Pattern[0] = '*') OR (Pattern[0] = '?') THEN
        IF l = 1 THEN
          Pos[0].Pos := 0;
          IF Pattern[0] = '*' THEN
            Pos[0].Pos := 0;
            Pos[0].Len := Length(Source);
          ELSE
            Pos[0] := PosLen(0,1);
          END; (*IF*)
          RETURN TRUE;
        ELSE
          s := 0;
        END; (*IF*)
      ELSE
        s := CharPos(Source,Pattern[0]);
        IF s = MAX(CARDINAL) THEN
          RETURN FALSE;
        END; (*IF*)
      END; (*IF*)
      n := 0;
      p := 1;
      WHILE p < l DO
        INC(s);
        IF (s > HIGH(Source)) OR (Source[s] = 0C) THEN
          RETURN FALSE;
        END; (*IF*)
        CASE Pattern[p] OF
          '?'           : IF n <= HIGH(Pos) THEN
                            Pos[n].Pos := s;
                            Pos[n].Len := 1;
                            INC(n);
                          END; (*IF*)                                     |
          '*'           : IF n <= HIGH(Pos) THEN
                            Pos[n].Pos := s;
                            IF (p >= HIGH(Pattern)) OR (Pattern[p+1] = 0C) THEN
                              RETURN TRUE;
                            ELSE
                              Pos[n].Len := NextPos(Source,Pattern[p+1],s); (* s/b NextCharPos *)
                              IF Pos[n].Len = MAX(CARDINAL) THEN
                                RETURN FALSE;
                              ELSE
                                DEC(Pos[n].Len,s);
                                INC(s,Pos[n].Len);
                                INC(n);
                              END; (*IF*)
                            END; (*IF*)
                          END; (*IF*)
                          INC(p);                                         |
        ELSE
          IF CAP(Pattern[p]) # CAP(Source[s]) THEN
            RETURN FALSE;
          END; (*IF*)
        END; (*CASE*)
        INC(p);
      END; (*WHILE*)
      RETURN TRUE;
    END FindSubStr;
(*# restore *)


(* The following were Implemented in asmlib *) (* --- *)

PROCEDURE Caps(VAR S: ARRAY OF CHAR);
VAR I : CARDINAL;
BEGIN
  FOR I := 0 TO HIGH(S) DO S[I] := CAP(S[I]); END;
END Caps;


PROCEDURE Compare(S1,S2: ARRAY OF CHAR) : INTEGER;
VAR
  L1,L2,L,Index : CARDINAL;
BEGIN
  L1 := Length(S1);
  L2 := Length(S2);
  IF L1<L2 THEN L := L1 ELSE L := L2 END;
  Index := Lib.Compare(ADR(S1),ADR(S2),L);
  IF (Index<L) THEN
    IF S1[Index] < S2[Index] THEN
      RETURN -1
    ELSE
      RETURN 1;
    END;
  ELSIF (L1=L2) THEN
    RETURN 0
  ELSIF (L1<L2) THEN
    RETURN -1
  ELSE
    RETURN 1;
  END;
END Compare;


PROCEDURE Length(S1: ARRAY OF CHAR) : CARDINAL;
VAR I : CARDINAL;
BEGIN
  RETURN Lib.ScanR(ADR(S1),HIGH(S1)+1,0);
END Length;


PROCEDURE Append(VAR Ns: ARRAY OF CHAR; S: ARRAY OF CHAR);
VAR
  I,J : CARDINAL;
  c : CHAR;
BEGIN
  I := Length(Ns);
  J := 0;
  WHILE (I <= HIGH(Ns)) AND (J <= HIGH(S))  AND (S[J] <> CHR(0)) DO
    Ns[I] := S[J];
    INC(I);
    INC(J);
  END;
  IF I<=HIGH(Ns) THEN Ns[I] := CHR(0) END;
END Append;


PROCEDURE Copy(VAR Ns: ARRAY OF CHAR; S: ARRAY OF CHAR);
VAR
  H,L : CARDINAL;
BEGIN
  H := HIGH(Ns)+1;
  L := Length(S);
  IF L > H THEN L := H END;
  Lib.Move(ADR(S),ADR(Ns),L);
  IF L < H THEN Ns[L] := CHR(0) END;
END Copy;


PROCEDURE Concat(VAR Ns: ARRAY OF CHAR; S1,S2: ARRAY OF CHAR);
VAR
  I,J : CARDINAL;
BEGIN
  J := 0;
  WHILE (J <= HIGH(Ns)) AND (J <= HIGH(S1)) AND (S1[J] <> CHAR(0)) DO
    Ns[J] := S1[J];
    INC(J);
  END;

  I := 0;
  LOOP
    IF (J > HIGH(Ns)) THEN EXIT; END;
    IF (I > HIGH(S2)) THEN Ns[J] := CHR(0); EXIT; END;
    Ns[J] := S2[I];
    IF S2[I] = CHR(0) THEN EXIT; END;
    INC(I);
    INC(J);
  END;
END Concat;


PROCEDURE Pos(S,P: ARRAY OF CHAR) : CARDINAL;
VAR
  I,J,K,HP,HS : CARDINAL;
BEGIN
  HP := HIGH(P);
  HS := HIGH(S);
  I  := 0;
  LOOP
    IF (I > HS) OR (S[I] = CHR(0)) THEN RETURN MAX(CARDINAL) END;
    J := 0;
    K := I;
    LOOP
      IF (J > HP) OR (P[J] = CHR(0)) THEN RETURN I END;
      IF K > HS THEN RETURN MAX( CARDINAL ); END;
      IF S[K] # P[J] THEN EXIT END;
      INC(J);
      INC(K);
    END;
    INC(I);
  END;
END Pos;

(* -- *)

PROCEDURE StrToC(S: ARRAY OF CHAR; VAR D: ARRAY OF CHAR): BOOLEAN;

VAR
  n: CARDINAL;
  c: CHAR;
BEGIN
  n := 0;
  LOOP
    IF n > HIGH(D) THEN
      RETURN FALSE;
    END;
    IF n > HIGH(S) THEN
      c := 0C;
    ELSE
      c := S[n];
    END;
    D[n] := c;
    IF c = 0C THEN
      RETURN TRUE
    END;
    INC(n);
  END;
END StrToC;

PROCEDURE StrToPas(S: ARRAY OF CHAR; VAR D: ARRAY OF CHAR): BOOLEAN;

VAR
  n: CARDINAL;
  c: CHAR;
BEGIN
  n := 1;
  LOOP
    IF n > HIGH(D) THEN
      D[0] := 0C;
      RETURN FALSE;
    END;
    IF n > SIZE(S) THEN
      c := 0C;
    ELSE
      c := S[n-1];
    END;
    IF c = 0C THEN
      D[0] := CHAR(n-1);
      RETURN TRUE
    END;
    D[n] := c;
    INC(n);
  END;
END StrToPas;


BEGIN
  FloatUse := FALSE;
END Str.
